      PROGRAM HWIGPR
C---COMMON BLOCKS ARE INCLUDED AS FILE HERWIG65.INC
      INCLUDE 'HERWIG65.INC'
      INCLUDE 'charybdis1003.inc'
      INTEGER N
      DOUBLE PRECISION HWRUNI
      EXTERNAL HWUDAT,HWRUNI,CHDATA
C---MAX NUMBER OF EVENTS THIS RUN
      MAXEV=100
C---BEAM PARTICLES
      PART1='P'
      PART2='P'
C---BEAM MOMENTA
      PBEAM1=7000.0D0
      PBEAM2=7000.0D0
C---PROCESS
      IPROC=-100
C---INITIALISE OTHER COMMON BLOCKS
      CALL HWIGIN
C---USER CAN RESET PARAMETERS AT
C   THIS POINT, OTHERWISE DEFAULT
C   VALUES IN HWIGIN WILL BE USED.
      PRVTX = .FALSE.
      MAXPR = 1
C---CHARYBDIS PARAMETERS CAN ALSO BE RESET HERE
      TOTDIM=8
      YRCSEC=.TRUE.
      RMBOIL=.TRUE.
      RMMINM=200.D0
C---DEFINE BLACK HOLE
      NRES=NRES+1
      RNAME(NRES)='BlacHole'
      IDPDG(NRES)=40
C---COMPUTE PARAMETER-DEPENDENT CONSTANTS
      CALL HWUINC
C---CALL HWUSTA TO MAKE ANY PARTICLE STABLE
      CALL HWUSTA('PI0     ')
C---USER'S INITIAL CALCULATIONS
      CALL HWABEG
C---INITIALISE ELEMENTARY PROCESS
      CALL HWEINI
C---LOOP OVER EVENTS
      DO 100 N=1,MAXEV
C---INITIALISE EVENT
      CALL HWUINE
C---GENERATE HARD SUBPROCESS
      CALL HWEPRO
C--RELABEL HARD AS BLACK HOLE
      IDHW(6)=NRES
      IDHEP(6)=40
C---GENERATE PARTON CASCADES
      CALL HWBGEN
C---DO HEAVY OBJECT DECAYS
      CALL HWDHOB
C---DO CLUSTER FORMATION
      CALL HWCFOR
C---DO CLUSTER DECAYS
      CALL HWCDEC
C---DO UNSTABLE PARTICLE DECAYS
      CALL HWDHAD
C---DO HEAVY FLAVOUR HADRON DECAYS
      CALL HWDHVY
C---ADD SOFT UNDERLYING EVENT IF NEEDED
      CALL HWMEVT
C---FINISH EVENT
      CALL HWUFNE
C---USER'S EVENT ANALYSIS
      CALL HWANAL
  100 CONTINUE
C---TERMINATE ELEMENTARY PROCESS
      CALL HWEFIN
C---USER'S TERMINAL CALCULATIONS
      CALL HWAEND
      STOP
      END
C----------------------------------------------------------------------
      SUBROUTINE HWABEG
C     USER'S ROUTINE FOR INITIALIZATION
C----------------------------------------------------------------------
      END
C----------------------------------------------------------------------
      SUBROUTINE HWAEND
C     USER'S ROUTINE FOR TERMINAL CALCULATIONS, HISTOGRAM OUTPUT, ETC
C----------------------------------------------------------------------
      END
C----------------------------------------------------------------------
      SUBROUTINE HWANAL
C     USER'S ROUTINE TO ANALYSE DATA FROM EVENT
C----------------------------------------------------------------------
      INCLUDE 'HERWIG65.INC'
      DOUBLE PRECISION PTOTAL(4),EPS
      INTEGER ITOTAL,I,J
      PARAMETER(EPS=1.0D-4)
C--TEST CHARGE AND MOMENTUM CONSERVATION
      IF(IERROR.NE.0) RETURN
      DO I=1,4
         PTOTAL(I) = ZERO
      ENDDO
      ITOTAL = 0
      DO I=1,NHEP
         IF(ISTHEP(I).EQ.1) THEN
            ITOTAL = ITOTAL+ICHRG(IDHW(I))
            DO J=1,4
               PTOTAL(J) = PTOTAL(J)+PHEP(J,I)
            ENDDO
         ENDIF
      ENDDO
      DO I=1,2
         ITOTAL = ITOTAL-ICHRG(IDHW(I))
         DO J=1,4
            PTOTAL(J) = PTOTAL(J)-PHEP(J,I)
         ENDDO
      ENDDO
      IF(ITOTAL.NE.0) PRINT *,
     &     'NON-CONSERVATION OF CHARGE: CHARGE VIOLATION=',ITOTAL
      DO J=1,4
         IF(ABS(PTOTAL(J)).GT.EPS) PRINT *,
     &     'NON-CONSERVATION OF MOMENTUM: MOMENTUM VIOLATION=',PTOTAL(J)
      ENDDO
      END
C----------------------------------------------------------------------
CDECK  ID>, CHDATA.
*CMZ :-        -21/08/06  10.33.53  by  Peter Richardson
*-- Author :    
C-----------------------------------------------------------------------
      BLOCK DATA CHDATA
C-----------------------------------------------------------------------
C    BLOCK DATA TO SET INITIAL VALUES OF PARAMETERS
C-----------------------------------------------------------------------
      IMPLICIT NONE
      INCLUDE 'charybdis1003.inc'
C--Les Houches run common block
      INTEGER MAXPUP
      PARAMETER(MAXPUP=100)
      INTEGER IDBMUP,PDFGUP,PDFSUP,IDWTUP,NPRUP,LPRUP
      DOUBLE PRECISION EBMUP,XSECUP,XERRUP,XMAXUP
      COMMON /HEPRUP/ IDBMUP(2),EBMUP(2),PDFGUP(2),PDFSUP(2),
     &                IDWTUP,NPRUP,XSECUP(MAXPUP),XERRUP(MAXPUP),
     &                XMAXUP(MAXPUP),LPRUP(MAXPUP)
C--event common block
C--Set MPLNCK and define what is meant by it:
C--MSSDEF=1 means M_GT, MSSDEF=2 means M_DL and MSSDEF=3 means M_D
      DATA MPLNCK /1000.0D0/
      DATA MSSDEF /2/
C--Set number of dimensions (number of EXTRA dimensions is n=TOTDIM-4)
C--TOTDIM can be in the range 6-11
      DATA TOTDIM/6/
C--Use Giddings+Thomas momentum scale for calling pdfs?
C--(See page 12 of hep-ph/0106219)
      DATA GTSCA /.FALSE./
C--Set mass window for black holes produced
      DATA  MINMSS /5000.0D0/
      DATA  MAXMSS /14000.0D0/
C--Set NBODY decay of BH remnant - NBODY can be in range 2-5.
      DATA NBODY /2/
C--Turn time variation of BH Hawking temperature in decay on or off
      DATA TIMVAR /.TRUE./
C--Set which decay products are to be used:
C--MSSDEC=1 gives no heavy particles
C--MSSDEC=2 gives t, W and Z as well
C--MSSDEC=3 gives t, W, Z and Higgs as well  
      DATA MSSDEC /3/
C--Turn grey-body factors on/off
      DATA GRYBDY /.TRUE./
C--Turn kinematic cut-off of decay on (rather than M=MPLANCK cut-off)
      DATA KINCUT /.FALSE./
C--BW mod 16/08/06: new parameters for version 1.003
C--Use Yoshino-Rychkov factors in cross-section
      DATA YRCSEC /.FALSE./
C--Max Hawking temperature
      DATA THWMAX /1000.0D0/
C--Remnant decay model: boiling at THWMAX
      DATA RMBOIL /.FALSE./
C--Min BH mass, ends boiling
      DATA RMMINM /1000.D0/
C--print out option (0=no printout, 1 =errors only, 2=errors+info)
      DATA IBHPRN /1/
C--pdf's for the beams (use the generator default)
C--MUST BE THE SAME FOR BOTH BEAMS
      DATA PDFGUP /-1,-1/
      DATA PDFSUP /-1,-1/
C--Beam particles and energies (only proton and/or antiproton)
      DATA IDBMUP /2212,2212/
      DATA EBMUP /7000.0D0,7000.0D0/
      END
CDECK  ID>, CHFMAS.
*CMZ :-        -17/07/03  18.11.30  by  Peter Richardson
*-- Author :    Peter Richardson
C----------------------------------------------------------------------
      FUNCTION CHFMAS(ID)
C----------------------------------------------------------------------
C     Function to return the mass of a SM particle input is PDG code
C     This is generator dependent
C----------------------------------------------------------------------
C--get the masses from the HERWIG common block
      INCLUDE 'HERWIG65.INC'
      INTEGER ID
      DOUBLE PRECISION CHFMAS
      IF(ABS(ID).LE.6) THEN
         CHFMAS = RMASS(ABS(ID))
      ELSEIF(ABS(ID).GE.11.AND.ABS(ID).LE.16) THEN
         CHFMAS = RMASS(110+ABS(ID))
      ELSEIF(ID.EQ.21) THEN
         CHFMAS = RMASS(13)
      ELSEIF(ID.EQ.22) THEN
         CHFMAS = 0.0D0
      ELSEIF(ID.EQ.23) THEN
         CHFMAS = RMASS(200)
      ELSEIF(ABS(ID).EQ.24) THEN
         CHFMAS = RMASS(198)
      ELSEIF(ID.EQ.25) THEN
         CHFMAS = RMASS(201)
      ELSE
         PRINT *,'CHFMAS WARNING UNKNOWN PARTICLE',ID
         STOP
      ENDIF
      END
CDECK  ID>, CHPDF.
*CMZ :-        -17/07/03  18.11.30  by  Peter Richardson
*-- Author :    Peter Richardson
C----------------------------------------------------------------------
      SUBROUTINE CHPDF(XXMINB,XLMINB,EMSCAB,XXB,DISFB)
C----------------------------------------------------------------------
C     Subroutine to calculate the pdfs
C     generator dependent
C----------------------------------------------------------------------
      INCLUDE 'HERWIG65.INC'
      DOUBLE PRECISION EMSCAB,XXB(2),DISFB(13,2),XXMINB,XLMINB,
     &     CHRUNI,UPV,DNV,USEA,DSEA,STR,CHM,BTM,TOP,GLU
      INTEGER IDB(2),I,J
      CHARACTER *8 DUMMY
      DOUBLE PRECISION VALUE(20)
      CHARACTER*20 PARM(20)
      LOGICAL FIRST
      EXTERNAL CHRUNI
      DATA VALUE/20*0D0/,PARM/20*' '/
      DATA FIRST/.TRUE./
C--Les Houches run common block
      INTEGER MAXPUP
      PARAMETER(MAXPUP=100)
      INTEGER IDBMUP,PDFGUP,PDFSUP,IDWTUP,NPRUP,LPRUP
      DOUBLE PRECISION EBMUP,XSECUP,XERRUP,XMAXUP
      COMMON /HEPRUP/ IDBMUP(2),EBMUP(2),PDFGUP(2),PDFSUP(2),
     &                IDWTUP,NPRUP,XSECUP(MAXPUP),XERRUP(MAXPUP),
     &                XMAXUP(MAXPUP),LPRUP(MAXPUP)
C--use generator internal pdfs
      IF(PDFGUP(1).LT.0) THEN
C---SET UP INITIAL STATE
         CALL HWUIDT(1,IDBMUP(1),IDB(1),DUMMY)
         PART1=DUMMY
         CALL HWUIDT(1,IDBMUP(2),IDB(2),DUMMY)
         PART2=DUMMY
         IPART1 = IDB(1)
         IPART2 = IDB(2)
         NHEP=1
         ISTHEP(NHEP)=101
         PHEP(1,NHEP)=0.0D0
         PHEP(2,NHEP)=0.0D0
         PHEP(3,NHEP)=EBMUP(1)
         PHEP(4,NHEP)=EBMUP(1)
         PHEP(5,NHEP)=RMASS(IDB(1))
         JMOHEP(1,NHEP)=0
         JMOHEP(2,NHEP)=0
         JDAHEP(1,NHEP)=0
         JDAHEP(2,NHEP)=0
         IDHW(NHEP)=IPART1
         IDHEP(NHEP)=IDPDG(IDB(1))
         NHEP=NHEP+1
         ISTHEP(NHEP)=102
         PHEP(1,NHEP)=0.0D0
         PHEP(2,NHEP)=0.0D0
         PHEP(3,NHEP)=-EBMUP(2)
         PHEP(4,NHEP)=EBMUP(2)
         PHEP(5,NHEP)=RMASS(IDB(2))
         JMOHEP(1,NHEP)=0
         JMOHEP(2,NHEP)=0
         JDAHEP(1,NHEP)=0
         JDAHEP(2,NHEP)=0
         IDHW(NHEP)=IPART2
         IDHEP(NHEP)=IDPDG(IPART2)
C---NEXT ENTRY IS OVERALL CM FRAME
         NHEP=NHEP+1
         IDHW(NHEP)=14
         IDHEP(NHEP)=0
         ISTHEP(NHEP)=103
         JMOHEP(1,NHEP)=NHEP-2
         JMOHEP(2,NHEP)=NHEP-1
         JDAHEP(1,NHEP)=0
         JDAHEP(2,NHEP)=0
         CALL CHVSUM(4,PHEP(1,NHEP-1),PHEP(1,NHEP-2),PHEP(1,NHEP))
         CALL CHUMAS(PHEP(1,NHEP))
         XLMIN = XLMINB
         EMSCA = EMSCAB
         XXMIN = XXMINB
         CALL HWSGEN(.TRUE.)
         DO I=1,2
            XXB(I) = XX(I)
            DO J=1,13
               DISFB(J,I) = DISF(J,I)
            ENDDO
         ENDDO
      ELSE
C--initialisation
         IF(FIRST) THEN
            IF(PDFGUP(1).NE.PDFGUP(2).OR.PDFSUP(1).NE.PDFSUP(2)) THEN
               print *,'MUST HAVE SAME PDF FOR BOTH BEAMS'
               STOP
            ENDIF
            PARM(1)='NPTYPE'
            VALUE(1)=1
            PARM(2)='NGROUP'
            VALUE(2)=PDFGUP(1)
            PARM(3)='NSET'
            VALUE(3)=PDFSUP(1)
            CALL PDFSET(PARM,VALUE)
            FIRST = .FALSE.
         ENDIF
         XXB(1)=EXP(CHRUNI(0,0.0D0,XLMINB))
         XXB(2)=XXMINB/XXB(1)
         DO I=1,2
            CALL STRUCTM(XXB(I),EMSCAB,
     &           UPV,DNV,USEA,DSEA,STR,CHM,BTM,TOP,GLU)
            DISFB( 3,I) = STR
            DISFB( 4,I) = CHM
            DISFB( 5,I) = BTM
            DISFB( 6,I) = TOP
            DISFB( 9,I) = STR
            DISFB(10,I) = CHM
            DISFB(11,I) = BTM
            DISFB(12,I) = TOP
            DISFB(13,I) = GLU
            IF(IDBMUP(I).GT.0) THEN
               DISFB(1,I) = DNV+DSEA
               DISFB(2,I) = UPV+USEA
               DISFB(7,I) = DSEA
               DISFB(8,I) = USEA
            ELSE
               DISFB(1,I) = DSEA
               DISFB(2,I) = USEA
               DISFB(7,I) = DNV+DSEA
               DISFB(8,I) = UPV+USEA
            ENDIF
         ENDDO
      ENDIF
      END
CDECK  ID>, CHRGEN.
*CMZ :-        -17/07/03  18.11.30  by  Peter Richardson
*-- Author :    Peter Richardson
C-----------------------------------------------------------------------
      FUNCTION CHRGEN(I)
C-----------------------------------------------------------------------
C     random number generator (just calls HERWIG or PYTHIA one)
C-----------------------------------------------------------------------
      IMPLICIT NONE
      DOUBLE PRECISION CHRGEN
      INTEGER I
C--use HERWIG random number generator
      DOUBLE PRECISION HWRGEN
      EXTERNAL HWRGEN
      CHRGEN = HWRGEN(I)
      END
CDECK  ID>, UPINIT.
*CMZ :-        -17/07/03  18.11.30  by  Peter Richardson
*-- Author :    Chris Harris and Peter Richardson
C----------------------------------------------------------------------
      SUBROUTINE UPINIT
C----------------------------------------------------------------------
C     Les Houches initialisation routine
C----------------------------------------------------------------------
      INCLUDE 'HERWIG65.INC'
      INCLUDE 'charybdis1003.inc'
C--Les Houches run common block
      INTEGER MAXPUP
      PARAMETER(MAXPUP=100)
      INTEGER IDBMUP,PDFGUP,PDFSUP,IDWTUP,NPRUP,LPRUP
      DOUBLE PRECISION EBMUP,XSECUP,XERRUP,XMAXUP
      COMMON /HEPRUP/ IDBMUP(2),EBMUP(2),PDFGUP(2),PDFSUP(2),
     &                IDWTUP,NPRUP,XSECUP(MAXPUP),XERRUP(MAXPUP),
     &                XMAXUP(MAXPUP),LPRUP(MAXPUP)
C--event common block
      INTEGER MAXNUP
      PARAMETER (MAXNUP=500)
      INTEGER NUP,IDPRUP,IDUP,ISTUP,MOTHUP,ICOLUP
      DOUBLE PRECISION XWGTUP,SCALUP,AQEDUP,AQCDUP,PUP,VTIMUP,SPINUP
      COMMON/HEPEUP/NUP,IDPRUP,XWGTUP,SCALUP,AQEDUP,AQCDUP,
     &              IDUP(MAXNUP),ISTUP(MAXNUP),MOTHUP(2,MAXNUP),
     &              ICOLUP(2,MAXNUP),PUP(5,MAXNUP),VTIMUP(MAXNUP),
     &              SPINUP(MAXNUP)
C--local variables
      INTEGER NCHSRCH,I
      DOUBLE PRECISION CHWSUM,CHWSQ,SPNZRO,SPNHLF,SPNONE,PTOTAL
      DOUBLE PRECISION PPROBS(6,3)
      DATA PPROBS /1.0d0, 1.0d0, 1.0d0, 1.0d0, 1.0d0, 1.0d0,
     &     0.773d0, 0.776d0, 0.761d0, 0.743d0, 0.726d0, 0.711d0,
     &     0.688d0, 0.827d0, 0.909d0, 0.959d0, 0.990d0, 1.011d0/
C--parameters for the initial maximum weight search
      DATA NCHSRCH /10000/
C--BW mod 16/08/06: set default values in BLOCK DATA CHDATA,
C  so that they can be reset in main program.
C--You can still change them here instead if you want.
C--Beam particles and energies (only proton=2212 and antiproton=-2212)
C--N.B.for HERWIG these are overidden by the values in the main program
C      IDBMUP(1) = 2212
C      IDBMUP(2) = 2212
C      EBMUP(1)  = 7000.0D0
C      EBMUP(2)  = 7000.0D0
C--Set MPLNCK and define what is meant by it:
C--MSSDEF=1 means M_GT, MSSDEF=2 means M_DL and MSSDEF=3 means M_D
C      MPLNCK=1000.0D0
C      MSSDEF=2
C--Set number of dimensions (number of EXTRA dimensions is n=TOTDIM-4)
C--TOTDIM can be in the range 6-11
C      TOTDIM=6
C--Use Giddings+Thomas momentum scale for calling pdfs?
C--(See page 12 of hep-ph/0106219)
C      GTSCA=.FALSE.
C--Set mass window for black holes produced
C      MINMSS=5000.0D0
C      MAXMSS=EBMUP(1)+EBMUP(2)
C--Set NBODY decay of BH remnant - NBODY can be in range 2-5.
C      NBODY=2
C--Turn time variation of BH Hawking temperature in decay on or off
C      TIMVAR=.TRUE.
C--Set which decay products are to be used:
C--MSSDEC=1 gives no heavy particles
C--MSSDEC=2 gives t, W and Z as well
C--MSSDEC=3 gives t, W, Z and Higgs as well  
C      MSSDEC=3
C--Turn grey-body factors on/off
C      GRYBDY=.TRUE.
C--Turn kinematic cut-off of decay on (rather than M=MPLANCK cut-off)
C      KINCUT=.FALSE.
C--BW mod 16/08/06: new parameters for version 1.003
C--Use Yoshino-Rychkov factors in cross-section
C      YRCSEC= .FALSE.
C--Max Hawking temperature
C      THWMAX =1000.0D0
C--Remnant decay model: boiling at THWMAX
C      RMBOIL = .FALSE.
C--Min BH mass, ends boiling
C      RMMINM = 1000.D0
C--print out option (0=no printout, 1 =errors only, 2=errors+info)
C      IBHPRN = 1
C--pdf's for the beams (use the generator default)
C--MUST BE THE SAME FOR BOTH BEAMS
C      PDFGUP(1) = -1
C      PDFGUP(2) = -1
C      PDFSUP(1) = -1
C      PDFSUP(2) = -1
C--------------------------------------------------------------------
C     END OF USER VARIABLES DON'T TOUCH ANYTHING BELOW HERE
C--------------------------------------------------------------------

C--HERWIG beams now passed from main program
      CALL HWUIDT(3,IDBMUP(1),I,PART1)
      CALL HWUIDT(3,IDBMUP(2),I,PART2)
      EBMUP(1)=PBEAM1
      EBMUP(2)=PBEAM2
C--end mod
C--probabilities for particles of different spin
C--(arbitrary normalisation)
      IF (GRYBDY) THEN
         SPNZRO = PPROBS(TOTDIM-5,1)
         SPNHLF = PPROBS(TOTDIM-5,2)
         SPNONE = PPROBS(TOTDIM-5,3)
      ELSE
         SPNZRO = 1d0
         SPNHLF = 0.750d0
         SPNONE = 1d0
      ENDIF
C--calculation of probability of emission for different particle types
C--only light SM particles
      IF (MSSDEC.EQ.1) THEN
         PTOTAL = (78.0d0*SPNHLF)+(18.0d0*SPNONE)
         PQUARK = (60.0d0*SPNHLF)/PTOTAL
         PLEPT  = (12.0d0*SPNHLF)/PTOTAL
         PNEUT  = (6.0d0*SPNHLF)/PTOTAL
         PGLUON = (16.0d0*SPNONE)/PTOTAL
         PGAMMA = (2.0d0*SPNONE)/PTOTAL
         PWBOSN = 0.0D0
         PZBOSN = 0.0D0
         PHIGGS = 0.0D0   
C--light SM partcles + top W/Z      
      ELSEIF (MSSDEC.EQ.2) THEN
         PTOTAL = (3.0d0*SPNZRO)+(90.0d0*SPNHLF)+(24.0d0*SPNONE)
         PQUARK = (72.0d0*SPNHLF)/PTOTAL
         PLEPT  = (12.0d0*SPNHLF)/PTOTAL
         PNEUT  = (6.0d0*SPNHLF)/PTOTAL
         PGLUON = (16.0d0*SPNONE)/PTOTAL
         PGAMMA = (2.0d0*SPNONE)/PTOTAL
         PZBOSN = (SPNZRO+(2.0d0*SPNONE))/PTOTAL
         PWBOSN = 2.0d0*PZBOSN
         PHIGGS = 0.0D0 
C--light SM particles +top W/Z and Higgs
      ELSE
         PTOTAL = (4.0d0*SPNZRO)+(90.0d0*SPNHLF)+(24.0d0*SPNONE)
         PQUARK = (72.0d0*SPNHLF)/PTOTAL
         PLEPT  = (12.0d0*SPNHLF)/PTOTAL
         PNEUT  = (6.0d0*SPNHLF)/PTOTAL
         PGLUON = (16.0d0*SPNONE)/PTOTAL
         PGAMMA = (2.0d0*SPNONE)/PTOTAL
         PZBOSN = (SPNZRO+(2.0d0*SPNONE))/PTOTAL
         PWBOSN = 2.0d0*PZBOSN
         PHIGGS = SPNZRO/PTOTAL
      ENDIF
C--what do do with the weights(here are generating weighted events)
      IDWTUP = 1
C--only one process
      NPRUP  = 1
C--communication code
      LPRUP(1) = 1
C--calculate the maximum weight
      CHWSUM = 0.0D0
      CHWSQ = 0.0D0
      XMAXUP(1) = 0.0D0
      DO I=1,NCHSRCH
         CALL CHEVNT(.FALSE.)
         CHWSUM = CHWSUM+XWGTUP
         CHWSQ  = CHWSQ+XWGTUP**2
         XMAXUP(1) = MAX(XMAXUP(1),XWGTUP)
      ENDDO
      CHWSUM = CHWSUM/DBLE(NCHSRCH)
      CHWSQ  = MAX(CHWSQ/DBLE(NCHSRCH)-CHWSUM**2,0.0D0)
      CHWSQ  = SQRT(CHWSQ/ DBLE(NCHSRCH))
C--cross section
      XSECUP(1) = CHWSUM
C--error on the cross section
      XERRUP(1) = CHWSQ
C--output initialisation information
C--header
      WRITE(*,10)
C--beam parameters
      WRITE(*,11) IDBMUP(1),EBMUP(1),IDBMUP(2),EBMUP(2)
C--basic parameters
      WRITE(*,12) MINMSS,MAXMSS,MPLNCK,THWMAX,RMMINM,MSSDEF,TOTDIM,
     &     YRCSEC,TIMVAR,GRYBDY,KINCUT,RMBOIL
      IF (RMBOIL) THEN
         IF (KINCUT) THEN
            WRITE (*,8)
 8          FORMAT(/10X,'KINEMATIC CUT INCONSISTENT'/
     &              10X,'WITH BOILING REMNANT MODEL:'/
     &              10X,'RESETTING KINCUT = .FALSE.'/)
            KINCUT=.FALSE.
         ENDIF
      ELSE
         IF (RMMINM.LT.MPLNCK) THEN
            WRITE (*,9)
 9          FORMAT(/10X,'BOILING REMNANT MODEL NOT USED:'/ 
     &              10X,'RESETTING MIN REMNANT MASS = MPLNCK'/)
            RMMINM=MPLNCK
         ENDIF
      ENDIF
C--choice of outgoing particles
      IF(MSSDEC.EQ.1) THEN
         WRITE(*,13)
      ELSEIF(MSSDEC.EQ.2) THEN
         WRITE(*,14)
      ELSEIF(MSSDEC.EQ.3) THEN
         WRITE(*,15)
      ENDIF
C--choice of scale
      IF(GTSCA) THEN
         WRITE(*,17)
      ELSE
         WRITE(*,18)
      ENDIF
C--information on the cross section
      WRITE(*,19) XSECUP(1),XERRUP(1),XMAXUP(1)
C--particle production probabilites
      WRITE(*,20) PQUARK,PLEPT,PNEUT,PGLUON,PGAMMA,PZBOSN,PWBOSN,PHIGGS
      RETURN
C--format statements for the output
 10   FORMAT(//10X,'       CHARYBDIS 1.003   August 2006          ',//,
     &         10X,'Please reference: C.M.Harris, P.Richardson &',/,
     &         10X,'B.R.Webber,JHEP0308(2003)033 [hep-ph/0307305]'/)
 11   FORMAT(/10X,'INPUT CONDITIONS FOR THIS RUN'//
     &        10X,'BEAM 1 (',I8,') ENG. =',F10.2/
     &        10X,'BEAM 2 (',I8,') ENG. =',F10.2/)
 12   FORMAT(
     &     10X,'MINIMUM BH MASS    =',F11.2/
     &     10X,'MAXIMUM BH MASS    =',F11.2/
     &     10X,'PLANCK MASS        =',F11.2/
     &     10X,'MAX HAWKING TEMP   =',F11.2/
     &     10X,'MIN REMNANT MASS   =',F11.2/
     &     10X,'DEFN OF PLANCK MASS=',I5/
     &     10X,'NO. OF DIMENSIONS  =',I5/
     &     10X,'YOSHINO-RYCHKOV C-S=',L5/
     &     10X,'TIME VARIATION     =',L5/
     &     10X,'GREY BODY EFFECTS  =',L5/
     &     10X,'KINEMATIC CUT      =',L5/
     &     10X,'BOILING REMN. MODEL=',L5)
 13   FORMAT(
     &     10X,'ONLY LIGHT SM PARTICLES PRODUCED')
 14   FORMAT(
     &     10X,'ALL SM PARTICLES BUT HIGGS PRODUCED')
 15   FORMAT(
     &     10X,'ALL SM PARTICLES PRODUCED')
      WRITE(*,16) NBODY
 16   FORMAT(
     &     10X,'PRODUCING ',I1,' PARTICLES IN REMNANT DECAY')
 17   FORMAT(
     &     10X,'USING BLACK HOLE RADIUS AS SCALE')
 18   FORMAT(
     &     10X,'USING BLACK HOLE MASS AS SCALE')
 19   FORMAT(
     &     10X,'CROSS SECTION (PB) =',G12.4/
     &     10X,'ERROR IN C-S  (PB) =',G12.4/
     &     10X,'MAXIMUM WEIGHT     =',E12.4)
 20   FORMAT(/10X,'PARTICLE PRODUCTION PROBABILITIES'//
     &        10X,'QUARK                  =',F10.4/
     &        10X,'CHARGED LEPTON         =',F10.4/
     &        10X,'NEUTRINO               =',F10.4/
     &        10X,'GLUON                  =',F10.4/
     &        10X,'PHOTON                 =',F10.4/
     &        10X,'Z BOSON                =',F10.4/
     &        10X,'W BOSON                =',F10.4/
     &        10X,'HIGGS BOSON            =',F10.4)
      END
